var ColorSprite = cc.Sprite.extend({
    name_color:null,
    ctor:function(filename, color_name){
        this._super(filename);
        this.name_color = color_name;
    },
    setColorName:function(color_name){
        this.name_color = color_name;
    },
    getColorName:function(){
        return this.name_color;
    }
});


var Stage3Layer = cc.Layer.extend({
    sprite_background:null,
    menu_retry:null,
                                      
    arry_color_name:null,
    arry_color_order:null,
    n_cur_index:null,
                                      
    sprite_monkey:null,
    sprite_color_name:null,
                                      
    sprite_color_1:null,
    sprite_color_2:null,
    sprite_color_3:null,
    sprite_color_4:null,
    sprite_color_5:null,
    sprite_color_6:null,
    
    ani_normal:null,
    ani_fail:null,
    ani_success:null,
    ani_right:null,
    
    sprite_listener1:null,
    sprite_listener2:null,
    sprite_listener3:null,
    sprite_listener4:null,
    sprite_listener5:null,
    sprite_listener6:null,
    
    sprite_select:null,
    
    star_ad:null,
    
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();

		cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
           	onKeyReleased: function(keyCode, event) {
               	if (keyCode == cc.KEY.back) {
           			ddStopAllEffect();
                	cc.director.popScene();
           		}
        }}, this);
		
		this.createAni();

        // ask the window size
        var size = cc.winSize;
        this.n_cur_index = 0;

        var sprite_background = new cc.Sprite("res/stage3/background3.jpg");
        sprite_background.x = size.width / 2;
        sprite_background.y = size.height / 2;
        resetScale(sprite_background);
        this.addChild(sprite_background, 0);
                                  
        this.sprite_background = new ColorSprite("res/stage3/back_Red.png", "Red");
        this.sprite_background.setOpacity(0);
        this.sprite_background.x = size.width / 2;
        this.sprite_background.y = size.height / 2;
        resetScale(this.sprite_background);
        this.addChild(this.sprite_background, 1);
                                  
        this.sprite_monkey = new cc.Sprite("res/stage3/monkey_eat.png");
        this.sprite_monkey.x = size.width / 2.0;
        this.sprite_monkey.y = size.height / 2.0 + 50;
        this.sprite_monkey.scale = 1.6;
        this.addChild(this.sprite_monkey, 2);
                                  
        var sprite_desktop = new cc.Sprite("res/stage3/desktop.png");
        sprite_desktop.x = size.width / 2;
        sprite_desktop.y = size.height / 2;
        this.addChild(sprite_desktop, 3);
                                      
        this.arry_color_name = ["Red", "Blue", "Yellow", "Orange", "Green", "Purple"];
                                      
        this.sprite_color_1 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 1) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 1) % 6]);
        this.sprite_color_1.x = size.width / 2.0 - 425;
        this.sprite_color_1.y = 100;
        this.sprite_color_1.setOpacity(0);
        //        this.sprite_color_1.setVisible(false);
        this.addChild(this.sprite_color_1, 4);
        cc.log("sprite color 1 name is " + this.sprite_color_1.getColorName());
                                      
        this.sprite_color_2 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 2) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 2) % 6]);
        this.sprite_color_2.x = size.width / 2.0 - 255;
        this.sprite_color_2.y = 100;
        this.sprite_color_2.setOpacity(0);
        //        this.sprite_color_1.setVisible(false);
        this.addChild(this.sprite_color_2, 5);
        cc.log("sprite color 2 name is " + this.sprite_color_2.getColorName());
                                      
        this.sprite_color_3 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 3) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 3) % 6]);
        this.sprite_color_3.x = size.width / 2.0 - 85;
        this.sprite_color_3.y = 100;
        this.sprite_color_3.setOpacity(0);
        //        this.sprite_color_1.setVisible(false);
        this.addChild(this.sprite_color_3, 6);
        cc.log("sprite color 3 name is " + this.sprite_color_3.getColorName());
                                      
        this.sprite_color_4 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 4) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 4) % 6]);
        this.sprite_color_4.x = size.width / 2.0 + 85;
        this.sprite_color_4.y = 100;
        this.sprite_color_4.setOpacity(0);
        //        this.sprite_color_1.setVisible(false);
        this.addChild(this.sprite_color_4, 7);
        cc.log("sprite color 4 name is " + this.sprite_color_4.getColorName());
                                      
        this.sprite_color_5 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 5) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 5) % 6]);
        this.sprite_color_5.x = size.width / 2.0 + 255;
        this.sprite_color_5.y = 100;
        this.sprite_color_5.setOpacity(0);
        //        this.sprite_color_1.setVisible(false);
        this.addChild(this.sprite_color_5, 8);
        cc.log("sprite color 5 name is " + this.sprite_color_5.getColorName());
                                      
        this.sprite_color_6 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 6) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 6) % 6]);
        this.sprite_color_6.x = size.width / 2.0 + 425;
        this.sprite_color_6.y = 100;
        this.sprite_color_6.setOpacity(0);
//        this.sprite_color_1.setVisible(false);
        this.addChild(this.sprite_color_6, 9);
        cc.log("sprite color 6 name is " + this.sprite_color_6.getColorName());
                                  
        this.sprite_color_name = new cc.Sprite("res/stage3/label_Red.png");
        this.sprite_color_name.setOpacity(0);
        this.sprite_color_name.x = size.width - 150;
        this.sprite_color_name.y = size.height / 2.0 + 50;
        this.addChild(this.sprite_color_name, 10);
                                      
        var arry_menu_item = [];
        var closeItem = new cc.MenuItemImage(
            "res/RetBtnNormal.png",
            "res/ReturnBtnHigh.png",
            function () {
                this.removeAllChildren();
                cc.director.popToRootScene();
            }, this);
        closeItem.attr({
            x: isFullScreenDevice()?170:70,
            y: size.height - 70,
            anchorX: 0.5,
            anchorY: 0.5,
            scale:0.8
        });
        arry_menu_item[0] = closeItem;
                                    
        this.menu_retry = new cc.MenuItemImage(
            "res/RetryBtnNormal.png",
            "res/RetryBtnHigh.png",
            function(){
                cc.log("replay menu is clicked!");
                ddStopAllEffect();
                this.reshuffleGame(true);
        }, this);
        this.menu_retry.setVisible(false);
        this.menu_retry.attr({
                x: size.width / 2.0,
                y: 100,
                anchorX: 0.5,
                anchorY: 0.5
        });
        arry_menu_item[1] = this.menu_retry;
                                      
        var menu = new cc.Menu(arry_menu_item);
        menu.x = 0;
        menu.y = 0;
        this.addChild(menu, 11);
                                      
        var self = this;
        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                                                                                    
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                                     
                self.sprite_select = null;
                if (cc.rectContainsPoint(rect, locationInNode)) {
                	self.sprite_select = target;
                	
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
            	if (!self.sprite_select) {
					return;
				}
                var delta = touch.getDelta();
                self.sprite_select.x += delta.x;
                self.sprite_select.y += delta.y;
            },
            onTouchEnded: function (touch, event) {
            	var end_position = cc.p(size.width / 2, size.height / 2 - 30);
            	var move_interval = 0.3;
            	var end_scale = 0.5;
            	if (!self.sprite_select) {
					return;
				}
            	
            	self.pauseListener();
            	
            	if (self.sprite_select == self.sprite_color_1) {
            		if(self.sprite_background.getColorName() == self.sprite_select.getColorName() ){
                        ddPlayEffect('',"res/sound/great.mp3", false);
                        //cc.audioEngine.playEffect("res/sound/great.mp3", false);
                        self.sprite_color_1.runAction(cc.sequence(
                        		cc.spawn(cc.moveTo(move_interval, end_position), cc.scaleTo(move_interval, end_scale, end_scale)),
                        		cc.fadeTo(move_interval, 0),
                        		cc.callFunc(function() {
                        			++self.n_cur_index;
                        			self.showSuccessMonkey();
								}.bind(self))
                        ));                                                         
                    }else{
                        self.sprite_color_1.x = size.width / 2.0 - 425;
                        self.sprite_color_1.y = 100;
                        self.showFailMonkey();
                        self.resumeListener();
                    }
            	} else if (self.sprite_select == self.sprite_color_2) {
            		if(self.sprite_background.getColorName() == self.sprite_select.getColorName()){
                    	ddPlayEffect('',"res/sound/great.mp3", false);
                    	self.sprite_color_2.runAction(cc.sequence(
                    			cc.spawn(cc.moveTo(move_interval, end_position), cc.scaleTo(move_interval, end_scale, end_scale)),
                    			cc.fadeTo(move_interval, 0),
                    			cc.callFunc(function() {
                    				++self.n_cur_index;
                    				self.showSuccessMonkey();
                    			}.bind(self))
                    	));
                    }else{
                        self.showFailMonkey();
                        self.sprite_color_2.x = size.width / 2.0 - 255;
                        self.sprite_color_2.y = 100;
                        self.resumeListener();
                    }
            	}else if (self.sprite_select == self.sprite_color_3) {
            		if(self.sprite_background.getColorName() == self.sprite_select.getColorName()){
                    	ddPlayEffect('',"res/sound/great.mp3", false);
                    	self.sprite_color_3.runAction(cc.sequence(
                    			cc.spawn(cc.moveTo(move_interval, end_position), cc.scaleTo(move_interval, end_scale, end_scale)),
                    			cc.fadeTo(move_interval, 0),
                    			cc.callFunc(function() {
                    				++self.n_cur_index;
                    				self.showSuccessMonkey();
                    			}.bind(self))
                    	));
                    }else{
                        self.showFailMonkey();
                        self.sprite_color_3.x = size.width / 2.0 - 85;
                        self.sprite_color_3.y = 100;
                        self.resumeListener();
                    }
            	}else if (self.sprite_select == self.sprite_color_4) {
            		if(self.sprite_background.getColorName() == self.sprite_select.getColorName()){
                    	ddPlayEffect('',"res/sound/great.mp3", false);
                    	self.sprite_color_4.runAction(cc.sequence(
                    			cc.spawn(cc.moveTo(move_interval, end_position), cc.scaleTo(move_interval, end_scale, end_scale)),
                    			cc.fadeTo(move_interval, 0),
                    			cc.callFunc(function() {
                    				++self.n_cur_index;
                    				self.showSuccessMonkey();
                    			}.bind(self))
                    	));
                    }else{
                        self.showFailMonkey();
                        self.sprite_color_4.x = size.width / 2.0 + 85;
                        self.sprite_color_4.y = 100;
                        self.resumeListener();
                    }
            	}else if (self.sprite_select == self.sprite_color_5) {
            		if(self.sprite_background.getColorName() == self.sprite_select.getColorName()){
                    	ddPlayEffect('',"res/sound/great.mp3", false);
                    	self.sprite_color_5.runAction(cc.sequence(
                    			cc.spawn(cc.moveTo(move_interval, end_position), cc.scaleTo(move_interval, end_scale, end_scale)),
                    			cc.fadeTo(move_interval, 0),
                    			cc.callFunc(function() {
                    				++self.n_cur_index;
                    				self.showSuccessMonkey();
                    			}.bind(self))
                    	));
                    }else{
                        self.showFailMonkey();
                        self.sprite_color_5.x = size.width / 2.0 + 255;
                        self.sprite_color_5.y = 100;
                        self.resumeListener();
                    }
            	}else if (self.sprite_select == self.sprite_color_6) {
            		if(self.sprite_background.getColorName() == self.sprite_select.getColorName()){
                    	ddPlayEffect('',"res/sound/great.mp3", false);
                    	
                    	self.sprite_color_6.runAction(cc.sequence(
                    			cc.spawn(cc.moveTo(move_interval, end_position), cc.scaleTo(move_interval, 0.5, 0.5)),
                    			cc.fadeTo(move_interval, 0),
                    			cc.callFunc(function() {
                    				self.sprite_color_6.scale = 1;
                    				++self.n_cur_index;
                    				self.showSuccessMonkey();
                    			}.bind(self))
                    	));
                    }else{
                        self.showFailMonkey();
                        self.sprite_color_6.x = size.width / 2.0 + 425;
                        self.sprite_color_6.y = 100;
                        self.resumeListener();
                    }
                }else {
                	self.resumeListener();
                }
        }});
        
        this.sprite_listener1 = sprite_listener.clone();
        this.sprite_listener1.retain();
        this.sprite_listener2 = sprite_listener.clone();
        this.sprite_listener2.retain();
        this.sprite_listener3 = sprite_listener.clone();
        this.sprite_listener3.retain();
        this.sprite_listener4 = sprite_listener.clone();
        this.sprite_listener4.retain();
        this.sprite_listener5 = sprite_listener.clone();
        this.sprite_listener5.retain();
        this.sprite_listener6 = sprite_listener.clone();
        this.sprite_listener6.retain();
        
        showStarAd(this, this.star_ad, cc.p(cc.winSize.width - 80, cc.winSize.height - 150));
                                  
        this.reshuffleGame(true);
                                  
        return true;
    },
                                  
    addListener:function(){
        cc.eventManager.addListener(this.sprite_listener1, this.sprite_color_1);
        cc.eventManager.addListener(this.sprite_listener2, this.sprite_color_2);
        cc.eventManager.addListener(this.sprite_listener3, this.sprite_color_3);
        cc.eventManager.addListener(this.sprite_listener4, this.sprite_color_4);
        cc.eventManager.addListener(this.sprite_listener5, this.sprite_color_5);
        cc.eventManager.addListener(this.sprite_listener6, this.sprite_color_6);
    },
                                  
    removeListeners:function(){
        cc.eventManager.removeListener(this.sprite_listener1);
        cc.eventManager.removeListener(this.sprite_listener2);
        cc.eventManager.removeListener(this.sprite_listener3);
        cc.eventManager.removeListener(this.sprite_listener4);
        cc.eventManager.removeListener(this.sprite_listener5);
        cc.eventManager.removeListener(this.sprite_listener6);
    },
    
    pauseListener:function(){
    	cc.eventManager.pauseTarget(this.sprite_color_1, true);
    	cc.eventManager.pauseTarget(this.sprite_color_2, true);
    	cc.eventManager.pauseTarget(this.sprite_color_3, true);
    	cc.eventManager.pauseTarget(this.sprite_color_4, true);
    	cc.eventManager.pauseTarget(this.sprite_color_5, true);
    	cc.eventManager.pauseTarget(this.sprite_color_6, true);
    	
    	console.log("pause target");
    },
    
    resumeListener:function(){
    	cc.eventManager.resumeTarget(this.sprite_color_1, true);
    	cc.eventManager.resumeTarget(this.sprite_color_2, true);
    	cc.eventManager.resumeTarget(this.sprite_color_3, true);
    	cc.eventManager.resumeTarget(this.sprite_color_4, true);
    	cc.eventManager.resumeTarget(this.sprite_color_5, true);
    	cc.eventManager.resumeTarget(this.sprite_color_6, true);
    	
    	console.log("resume target");
    },
    
    createAni:function(){
    	this.ani_normal = new cc.Animation();
    	this.ani_normal.setDelayPerUnit(0.2);
    	this.ani_normal.setRestoreOriginalFrame(false);
    	for (var n_index = 1; n_index < 12; n_index++) {
			this.ani_normal.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame("monkey_normal_" + n_index + ".png"));
		}
    	this.ani_normal.retain();
    	
    	this.ani_fail = new cc.Animation();
    	this.ani_fail.setDelayPerUnit(0.1);
    	this.ani_fail.setRestoreOriginalFrame(false);
    	for (var n_index = 1; n_index < 15; n_index++) {
    		this.ani_fail.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame("monkey_fail_" + n_index + ".png"));
    	}
    	this.ani_fail.retain();
    	
    	this.ani_right = new cc.Animation();
    	this.ani_right.setDelayPerUnit(0.07);
    	this.ani_right.setRestoreOriginalFrame(false);
    	for (var n_index = 1; n_index < 30; n_index++) {
    		this.ani_right.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame("monkey_right_" + n_index + ".png"));
    	}
    	this.ani_right.retain();
    	
    	this.ani_success = new cc.Animation();
    	this.ani_success.setDelayPerUnit(0.1);
    	this.ani_success.setRestoreOriginalFrame(false);
    	for (var n_index = 1; n_index < 36; n_index++) {
    		this.ani_success.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame("monkey_finish_" + n_index + ".png"));
    	}
    	this.ani_success.retain();
    },
    reshuffleScene:function(){
        if(6 == this.n_cur_index){
            this.removeListeners();
            this.menu_retry.setVisible(true);
            this.sprite_background.setVisible(false);
            this.sprite_color_name.setVisible(false);
            this.showFinishMonkey();
            return;
        }
        this.sprite_monkey.setTexture("res/stage3/monkey_eat.png");
        this.sprite_background.setTexture("res/stage3/back_" + this.arry_color_name[this.n_cur_index] + ".png");
        this.sprite_background.setColorName(this.arry_color_name[this.n_cur_index]);
                                  
        this.sprite_color_name.setTexture("res/stage3/label_" + this.arry_color_name[this.n_cur_index] + ".png");
        ddPlayEffect('',"res/sound/" + this.arry_color_name[this.n_cur_index] + ".mp3");
        //cc.audioEngine.playEffect("res/sound/" + this.arry_color_name[this.n_cur_index] + ".mp3");
        this.sprite_color_name.runAction(cc.sequence(
            cc.FadeTo(1, 255),
            cc.scaleTo(0.2, 0.7, 0.7),
            cc.scaleTo(0.4, 1.4, 1.4),
            cc.scaleTo(0.2, 1.0, 1.0), 
            cc.callFunc(function() {
                if(0 == this.n_cur_index){
                    this.addListener();
                }else{
                    this.resumeListener();
                }
            	
            }.bind(this))
        ));
        this.sprite_background.runAction(cc.FadeTo(1, 255));
    },
    reshuffleGame:function(restart){
        this.n_cur_index = 0;
        this.menu_retry.setVisible(false);
        this.sprite_background.setVisible(true);
        this.sprite_color_name.setVisible(true);
        
        var size = cc.winSize;
        this.sprite_color_1.x = size.width / 2.0 - 425;
        this.sprite_color_1.y = 100;
        this.sprite_color_2.x = size.width / 2.0 - 255;
        this.sprite_color_2.y = 100;
        this.sprite_color_3.x = size.width / 2.0 - 85;
        this.sprite_color_3.y = 100;
        this.sprite_color_4.x = size.width / 2.0 + 85;
        this.sprite_color_4.y = 100;
        this.sprite_color_5.x = size.width / 2.0 + 255;
        this.sprite_color_5.y = 100;
        this.sprite_color_6.x = size.width / 2.0 + 425;
        this.sprite_color_6.y = 100;
                                      
        var arry_color_order = [0, 1, 2, 3, 4, 5];
        this.reShuffleArray(arry_color_order);
        
        
        this.sprite_color_1.setTexture("res/stage1/" + this.arry_color_name[arry_color_order[0]] + Math.floor(Math.random() * 100) % 2 + ".png");
        this.sprite_color_1.setColorName(this.arry_color_name[arry_color_order[0]]);
        
        this.sprite_color_2.setTexture("res/stage1/" + this.arry_color_name[arry_color_order[1]] + Math.floor(Math.random() * 100) % 2 + ".png");
        this.sprite_color_2.setColorName(this.arry_color_name[arry_color_order[1]]);
        
        this.sprite_color_3.setTexture("res/stage1/" + this.arry_color_name[arry_color_order[2]] + Math.floor(Math.random() * 100) % 2 + ".png");
        this.sprite_color_3.setColorName(this.arry_color_name[arry_color_order[2]]);
        
        this.sprite_color_4.setTexture("res/stage1/" + this.arry_color_name[arry_color_order[3]] + Math.floor(Math.random() * 100) % 2 + ".png");
        this.sprite_color_4.setColorName(this.arry_color_name[arry_color_order[3]]);
        
        this.sprite_color_5.setTexture("res/stage1/" + this.arry_color_name[arry_color_order[4]] + Math.floor(Math.random() * 100) % 2 + ".png");
        this.sprite_color_5.setColorName(this.arry_color_name[arry_color_order[4]]);
        
        this.sprite_color_6.setTexture("res/stage1/" + this.arry_color_name[arry_color_order[5]] + Math.floor(Math.random() * 100) % 2 + ".png");
        this.sprite_color_6.setColorName(this.arry_color_name[arry_color_order[5]]);
        
        this.sprite_color_1.scale = 1;
        this.sprite_color_2.scale = 1;
        this.sprite_color_3.scale = 1;
        this.sprite_color_4.scale = 1;
        this.sprite_color_5.scale = 1;
        this.sprite_color_6.scale = 1;
        
        this.sprite_color_1.setVisible(true);
        this.sprite_color_2.setVisible(true);
        this.sprite_color_3.setVisible(true);
        this.sprite_color_4.setVisible(true);
        this.sprite_color_5.setVisible(true);
        this.sprite_color_6.setVisible(true);
                                    
        this.sprite_color_1.runAction(cc.FadeTo(1, 255));
        this.sprite_color_2.runAction(cc.FadeTo(1, 255));
        this.sprite_color_3.runAction(cc.FadeTo(1, 255));
        this.sprite_color_4.runAction(cc.FadeTo(1, 255));
        this.sprite_color_5.runAction(cc.FadeTo(1, 255));
        this.sprite_color_6.runAction(cc.fadeTo(1, 255));
                                  
        this.showNormalMonkey();
    },
    reShuffleArray:function (array) {
        var length = array.length;
        for (var i = 0; i < length; i++) {
        var sidx = Math.floor((Math.random()) * (length-1));
            if (sidx != i) {
                var tmp = array[i];
                array[i] = array[sidx];
                array[sidx] = tmp;
            }
        }
    },
    showFailMonkey:function(){
        this.sprite_monkey.stopAllActions();
                                
        this.sprite_monkey.runAction(cc.sequence(cc.animate(this.ani_fail), cc.callFunc(function(){
            this.sprite_monkey.setTexture("res/stage3/monkey_eat.png");
        }.bind(this))));
        ddPlayEffect('',"res/sound/fail.mp3", false);
    },
    showNormalMonkey:function(){
        var size = cc.winSize;
        this.sprite_monkey.stopAllActions();
                                  
        this.sprite_color_1.y = 800;
        this.sprite_color_2.y = 800;
        this.sprite_color_3.y = 800;
        this.sprite_color_4.y = 800;
        this.sprite_color_5.y = 800;
        this.sprite_color_6.y = 800;
                                  
        this.sprite_color_1.runAction(
            cc.spawn(
                cc.moveBy(0.3, cc.p(0, -700)),
                cc.FadeTo(0.3, 255)
            )
        );
                                  
        this.scheduleOnce(function sprite_animate(){
            this.sprite_color_2.runAction(
                cc.spawn(
                    cc.moveBy(0.3, cc.p(0, -700)),
                    cc.FadeTo(0.3, 255)
                )
            );
        } ,0.3);
        this.scheduleOnce(function sprite_animate(){
            this.sprite_color_3.runAction(
                cc.spawn(
                    cc.moveBy(0.3, cc.p(0, -700)),
                    cc.FadeTo(0.3, 255)
                )
            );
        } ,0.6);
                                  
        this.scheduleOnce(function sprite_animate(){
            this.sprite_color_4.runAction(
                cc.spawn(
                    cc.moveBy(0.3, cc.p(0, -700)),
                    cc.FadeTo(0.3, 255)
                )
            );
        } ,0.9);
        
        this.scheduleOnce(function sprite_animate(){
            this.sprite_color_5.runAction(
                cc.spawn(
                    cc.moveBy(0.3, cc.p(0, -700)),
                    cc.FadeTo(0.3, 255)
                )
            );
        } ,1.2);
                                  
        this.scheduleOnce(function sprite_animate(){
            this.sprite_color_6.runAction(
            	cc.spawn(
            		cc.moveBy(0.3, cc.p(0, -700)),
        			cc.FadeTo(0.3, 255)
          		)	
            );
        } ,1.5);
                                  
        
        this.sprite_monkey.runAction(cc.sequence(cc.animate(this.ani_normal), cc.callFunc(function(){
            this.reshuffleScene();
        }.bind(this))));
    },
    showSuccessMonkey:function(){
        this.sprite_monkey.stopAllActions();
                                  
        this.sprite_background.runAction(cc.FadeTo(3, 0));
        this.sprite_color_name.runAction(cc.FadeTo(3, 0));
        this.sprite_monkey.runAction(cc.sequence(cc.animate(this.ani_right), cc.callFunc(function(){
            this.reshuffleScene();
        }.bind(this))));
    },
    showFinishMonkey:function(){
        this.sprite_monkey.stopAllActions();
        
        this.sprite_monkey.runAction(cc.repeatForever(cc.animate(this.ani_success)));
        ddPlayEffect('',"res/sound/success.mp3", false);
    },
    onExitTransitionDidStart:function(){
    	releaseObj(this.ani_fail);
    	releaseObj(this.ani_success);
    	releaseObj(this.ani_right);
    	releaseObj(this.ani_normal);
        releaseObj(this.sprite_listener1);
        releaseObj(this.sprite_listener2);
        releaseObj(this.sprite_listener3);
        releaseObj(this.sprite_listener4);
        releaseObj(this.sprite_listener5);
        releaseObj(this.sprite_listener6);
    }
});

var Stage3Scene = cc.Scene.extend({
    ctor:function(){
        this._super();
        var layer = new Stage3Layer();
        this.addChild(layer);
    },
    onEnter:function () {
        this._super();
    }
});

